function [phis0 rs0] = calcGrindWheel(axisdistance,iw,is,dphis,phiw0,rw0)
%berechnen der Schleifscheibenkontur

global turnangle_quantity;

wquantity=length(phiw0);
squantity=floor(360/dphis)+1;
turnangle_quantity=squantity;

%Winkel  <=360
for windex=1:wquantity
	if phiw0(windex)<0
		phiw0(windex)=phiw0(windex)+2*pi;
	end
end

dalpha=dphis*pi/180;

rw0max=max(rw0);
rs0start=axisdistance+2*rw0max;
rs0=ones(1,squantity)*rs0start;
phis0=ones(1,squantity);
phis0(1)=0;
phis0(squantity)=2*pi;
for sindex=2:squantity-1
	phis0(sindex)=dalpha*(sindex-1);
end

%Berhrung des Schleifscheibenstrahls mit Werkstckkreis nur innerhalb plusminus gamma mglich
gamma=asin(rw0max/axisdistance);
sphimin=pi-gamma;
sphimax=pi+gamma;


angleincrement=2*pi/turnangle_quantity;

for turnangle=-pi/is:angleincrement:pi/is
	phiw=phiw0-turnangle*iw;
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	phis=phis0+turnangle*is;
	for windex=1:wquantity
		if phiw(windex)<0
			%phiw(windex)=phiw(windex)+2*pi;
		end
	end
	for sindex=1:squantity
		if phis(sindex)<0
			%phis(sindex)=phis(sindex)+2*pi;
		end
	end
	%phis=phis0+turnangle*is;
	%disp(turnangle);
	[xw yw]=pol2cart(phiw,rw0);
	xw=xw-axisdistance;
	
	windex1=wquantity;
	windex2=1;
	
	for windex=1:wquantity
		xw1=xw(windex1);
		yw1=yw(windex1);
		xw2=xw(windex2);
		yw2=yw(windex2);
		alpha1=atan2(yw1,xw1);
		alpha2=atan2(yw2,xw2);
		if alpha1<0
			alpha1=alpha1+2*pi;
		end
		if alpha2<0
			alpha2=alpha2+2*pi;
		end
		for sindex=1:squantity
			sphi=phis(sindex);
			if (sphi>=sphimin && sphi<=sphimax)
				tansphi=tan(sphi);
				
								
				if (sphi<=alpha1 && sphi>=alpha2) || (sphi>=alpha1 && sphi<=alpha2)
					quot=yw1 - yw2 + (xw2 - xw1)*tansphi;
					if abs(quot)>eps
						xsection=-(xw1*yw2 - xw2*yw1)/quot;
						ysection=tansphi*xsection;
					else
						%Schleifscheibenstrahl und Werkstckgerade sind parallel
						disp('parallel******************************************');
						%wenn sie aufeinander liegen.....
						if (abs(xw1*tansphi-yw1)<eps) && (abs(xw2*tansphi-yw2)<eps)
							disp('aufeinander************************************');
							r1=sqrt(xw1^2+yw1^2);
							r2=sqrt(xw2^2+yw2^2);
							[xsection ysection]=pol2cart(sphi,min(r1,r2));
						else
							%Dummiwerte
							xsection=-rs0start;
							ysection=-rs0start;
						end
					end
					rsection=sqrt(xsection^2+ysection^2);
					if rsection<rs0(sindex)
						rs0(sindex)=rsection;
					end
				end
			end
		end
		windex1=windex;
		windex2=windex+1;
	end
end
%disp(['phis0=',num2str(phis0)]);
%disp(['rs0=',num2str(rs0)]);