#include "mex.h"
#include <math.h>
#include <stdlib.h>

#define arrysize 3601
#define eps 0.000000000001
#define pi 3.141592654

//Berechnung der Schleifscheibenpunkte
void calcGrindWheel(int squantity,double axisdistance, double iw, double is, double dphis, double *phiw0, double *rw0, double *phis0, double *rs0, mwSize n) {

int wquantity;

double rw0max,rs0start;

double dalpha,gamma,sphimin,sphimax;

double turnangle_quantity=squantity;

double turnangle, angleincrement;

int i, sindex,windex,windex1,windex2;

double phiw[arrysize],phis[arrysize];
double sphi,tansphi;
double xw1,yw1,xw2,yw2,alpha1,alpha2;
double xsection,ysection,rsection;
double quot,r1,r2;

wquantity=n;

rw0max=rw0[0];
for (i=0; i<wquantity; i++) {
	if (rw0[i]>rw0max) {
		rw0max=rw0[i];
	}
}

rs0start=axisdistance+2*rw0max;
rs0start=pow(rs0start,2)*2;

dalpha=dphis*pi/180;
angleincrement=2*pi/turnangle_quantity;

gamma=asin(rw0max/axisdistance);
sphimin=pi-gamma;
sphimax=pi+gamma;



for (i=0; i<squantity; i++) {
	rs0[i] = rs0start;
	phis0[i]=dalpha*i;
}
phis0[0]=0;
phis0[squantity-1]=2*pi;

for (i=0;i<wquantity;i++) {
	if (phiw0[i]<0) {
		phiw0[i]=phiw0[i]+2*pi;
	}
}

//drehen von Werkstck und Schleifscheibe
for (turnangle=-pi/is;turnangle<=pi/is;turnangle=turnangle+angleincrement) {
	for (i=0;i<wquantity;i++) {
		phiw[i]=phiw0[i]-turnangle*iw;
		if (phiw[i]<0) {
			//phiw[i]=phiw[i]+2*pi;
		}
	}
	for (i=0;i<squantity;i++) {
		phis[i]=phis0[i]+turnangle*is;
		if (phis[i]<0) {
			//phis[i]=phis[i]+2*pi;
		}
	}	
	
	windex1=wquantity-1;
	windex2=0;
	
	for (windex=0;windex<wquantity;windex++) {
		xw1=rw0[windex1]*cos(phiw[windex1])-axisdistance;
		yw1=rw0[windex1]*sin(phiw[windex1]);
		xw2=rw0[windex2]*cos(phiw[windex2])-axisdistance;
		yw2=rw0[windex2]*sin(phiw[windex2]);
		alpha1=atan2(yw1,xw1);
		alpha2=atan2(yw2,xw2);
		if (alpha1<0) {
			alpha1=alpha1+2*pi;
		}
		if (alpha2<0) {
			alpha2=alpha2+2*pi;
		}
		for (sindex=0;sindex<squantity;sindex++) {
			sphi=phis[sindex];
			if (sphi>=sphimin && sphi<=sphimax) {
				tansphi=tan(sphi);				
				if ((sphi<=alpha1 && sphi>=alpha2) || (sphi>=alpha1 && sphi<=alpha2)) {
					quot=yw1 - yw2 + (xw2 - xw1)*tansphi;
					if (abs(quot)>eps) {
						xsection=-(xw1*yw2 - xw2*yw1)/quot;
						ysection=tansphi*xsection;
					}
					else {
						//%Schleifscheibenstrahl und Werkstckgerade sind parallel
						
						//%wenn sie aufeinander liegen.....
						if ((abs(xw1*tansphi-yw1)<eps) && (abs(xw2*tansphi-yw2)<eps)) {
							r1=sqrt(pow(xw1,2)+pow(yw1,2));
							r2=sqrt(pow(xw2,2)+pow(yw2,2));
							if (r1<r2) {
								xsection=r1*cos(sphi);
								ysection=r1*sin(sphi);
							}
							else {
								xsection=r2*cos(sphi);
								ysection=r2*sin(sphi);
							}							
						}
						else {
							//Dummiwerte
							xsection=-rs0start;
							ysection=-rs0start;
						}
					}
					rsection=pow(xsection,2)+pow(ysection,2);
					if (rsection<rs0[sindex]) {
						rs0[sindex]=rsection;
					}
				}
			}
		}
		windex1=windex;
		windex2=windex+1;
	}
}

//Wurzelziehen erst zum Schlu (Rechenzeit)
for (sindex=0;sindex<squantity;sindex++) {
	rs0[sindex]=sqrt(rs0[sindex]);
}
	
}

/* The gateway function */
void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {

//double Input
double axisdistance, dphis, is, iw;
//1xN Inputmatrix
double *phiw,*rw;
//Size der Inputmatrix
mwSize ncols;
//1xN Outputmatrix
double *phis0, *rs0;

int squantity;

/* check for proper number of arguments */
if(nrhs!=6) {
	mexErrMsgIdAndTxt("MyToolbox:arrayProduct:nrhs","6 inputs required.");
}
if(nlhs!=2) {
	//mexErrMsgIdAndTxt("MyToolbox:arrayProduct:nlhs","One output required.");
	// Fehler wenn z.B. Matlabaufruf: functionname(....
	// richtig wre: [phi r]=functionname(....
}
/* make sure the first input argument is scalar */
if( !mxIsDouble(prhs[0]) || 
	mxIsComplex(prhs[0]) ||
	mxGetNumberOfElements(prhs[0])!=1 ) {
	mexErrMsgIdAndTxt("MyToolbox:arrayProduct:notScalar","Input multiplier must be a scalar.");
}

/* check that number of rows in second input argument is 1 */
if(mxGetM(prhs[5])!=1) {
	mexErrMsgIdAndTxt("MyToolbox:arrayProduct:notRowVector","Input must be a row vector.");
}

/* get the value of the scalar input  */
axisdistance = mxGetScalar(prhs[0]);

/* get the value of the scalar input  */
iw = mxGetScalar(prhs[1]);
is = mxGetScalar(prhs[2]);
dphis = mxGetScalar(prhs[3]);
squantity=360.0/dphis+1;
if (squantity>arrysize) {
	squantity=arrysize;
}

/* create a pointer to the real data in the input matrix  */
phiw = mxGetPr(prhs[4]);
rw = mxGetPr(prhs[5]);

/* get dimensions of the input matrix */
ncols = mxGetN(prhs[5]);

/* create the output matrix */
plhs[0] = mxCreateDoubleMatrix(1,squantity,mxREAL);
plhs[1] = mxCreateDoubleMatrix(1,squantity,mxREAL);

/* get a pointer to the real data in the output matrix */
phis0 = mxGetPr(plhs[0]);
rs0 = mxGetPr(plhs[1]);

/* call the computational routine */
calcGrindWheel(squantity,axisdistance,iw,is,dphis,phiw,rw,phis0,rs0,ncols);
}
